﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using TLA.Microservice.Infrastructure.Data;

namespace TLA.Microservice.Infrastructure.Migrations
{
    [DbContext(typeof(TLAApplicationContext))]
    partial class TLAApplicationContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("ProductVersion", "5.0.13")
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.Address", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasDefaultValueSql("(newid())");

                    b.Property<string>("Locality")
                        .HasMaxLength(80)
                        .HasColumnType("nvarchar(80)");

                    b.Property<string>("Street")
                        .HasMaxLength(350)
                        .HasColumnType("nvarchar(350)");

                    b.Property<string>("ZipCode")
                        .HasMaxLength(15)
                        .HasColumnType("nvarchar(15)");

                    b.HasKey("Id");

                    b.ToTable("Address");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.Contact", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasDefaultValueSql("(newid())");

                    b.Property<string>("Email")
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.Property<Guid>("PhoneId")
                        .HasColumnType("uniqueidentifier");

                    b.HasKey("Id");

                    b.HasIndex("PhoneId");

                    b.ToTable("Contacts");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.LeadsPreference", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasDefaultValueSql("(newid())");

                    b.Property<Guid>("PriceRangeId")
                        .HasColumnType("uniqueidentifier");

                    b.Property<Guid>("UserId")
                        .HasColumnType("uniqueidentifier");

                    b.Property<string>("VehicleStyle")
                        .IsRequired()
                        .HasMaxLength(150)
                        .HasColumnType("nvarchar(150)");

                    b.Property<string>("VehicleType")
                        .IsRequired()
                        .HasMaxLength(150)
                        .HasColumnType("nvarchar(150)");

                    b.HasKey("Id");

                    b.HasIndex("PriceRangeId");

                    b.HasIndex("UserId");

                    b.ToTable("LeadsPreferences");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.LeadsVehicleMakerChoice", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasDefaultValueSql("(newid())");

                    b.Property<Guid>("LeadPreferenceId")
                        .HasColumnType("uniqueidentifier");

                    b.Property<Guid>("VehicleMakerId")
                        .HasColumnType("uniqueidentifier");

                    b.HasKey("Id");

                    b.HasIndex("LeadPreferenceId");

                    b.HasIndex("VehicleMakerId");

                    b.ToTable("LeadsVehicleMakerChoice");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.Phone", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasDefaultValueSql("(newid())");

                    b.Property<string>("CountryCode")
                        .HasMaxLength(5)
                        .HasColumnType("nvarchar(5)");

                    b.Property<string>("Number")
                        .HasMaxLength(15)
                        .HasColumnType("nvarchar(15)");

                    b.HasKey("Id");

                    b.ToTable("Phone");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.PriceRange", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasDefaultValueSql("(newid())");

                    b.Property<int?>("Maximum")
                        .HasColumnType("int");

                    b.Property<int?>("Minimum")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.ToTable("PriceRange");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.User", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasDefaultValueSql("(newid())");

                    b.Property<Guid>("AddressId")
                        .HasColumnType("uniqueidentifier");

                    b.Property<DateTime>("Birthdate")
                        .HasColumnType("date");

                    b.Property<Guid>("ContactsId")
                        .HasColumnType("uniqueidentifier");

                    b.Property<string>("Gender")
                        .HasMaxLength(10)
                        .HasColumnType("nvarchar(10)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(150)
                        .HasColumnType("nvarchar(150)");

                    b.Property<string>("Surname")
                        .IsRequired()
                        .HasMaxLength(150)
                        .HasColumnType("nvarchar(150)");

                    b.HasKey("Id");

                    b.HasIndex("AddressId");

                    b.HasIndex("ContactsId");

                    b.ToTable("User");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.VehicleMaker", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasDefaultValueSql("(newid())");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("VehicleMaker");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.Contact", b =>
                {
                    b.HasOne("TLA.Microservice.Domain.Entities.Phone", "Phone")
                        .WithMany("Contacts")
                        .HasForeignKey("PhoneId")
                        .HasConstraintName("FK__Contacts__Phone")
                        .IsRequired();

                    b.Navigation("Phone");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.LeadsPreference", b =>
                {
                    b.HasOne("TLA.Microservice.Domain.Entities.PriceRange", "PriceRange")
                        .WithMany("LeadsPreferences")
                        .HasForeignKey("PriceRangeId")
                        .HasConstraintName("FK__LeadsPreferences__PriceRange")
                        .IsRequired();

                    b.HasOne("TLA.Microservice.Domain.Entities.User", "User")
                        .WithMany("LeadsPreferences")
                        .HasForeignKey("UserId")
                        .HasConstraintName("FK__LeadsPreferences__User")
                        .IsRequired();

                    b.Navigation("PriceRange");

                    b.Navigation("User");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.LeadsVehicleMakerChoice", b =>
                {
                    b.HasOne("TLA.Microservice.Domain.Entities.LeadsPreference", "LeadPreference")
                        .WithMany("LeadsVehicleMakerChoices")
                        .HasForeignKey("LeadPreferenceId")
                        .HasConstraintName("FK__LeadsVehicleMaker__LeadPreferences")
                        .IsRequired();

                    b.HasOne("TLA.Microservice.Domain.Entities.VehicleMaker", "VehicleMaker")
                        .WithMany("LeadsVehicleMakerChoices")
                        .HasForeignKey("VehicleMakerId")
                        .HasConstraintName("FK__LeadsVehicleMaker__VehicleMaker")
                        .IsRequired();

                    b.Navigation("LeadPreference");

                    b.Navigation("VehicleMaker");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.User", b =>
                {
                    b.HasOne("TLA.Microservice.Domain.Entities.Address", "Address")
                        .WithMany("Users")
                        .HasForeignKey("AddressId")
                        .HasConstraintName("FK__User__AddressId")
                        .IsRequired();

                    b.HasOne("TLA.Microservice.Domain.Entities.Contact", "Contacts")
                        .WithMany("Users")
                        .HasForeignKey("ContactsId")
                        .HasConstraintName("FK__User__ContactsId")
                        .IsRequired();

                    b.Navigation("Address");

                    b.Navigation("Contacts");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.Address", b =>
                {
                    b.Navigation("Users");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.Contact", b =>
                {
                    b.Navigation("Users");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.LeadsPreference", b =>
                {
                    b.Navigation("LeadsVehicleMakerChoices");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.Phone", b =>
                {
                    b.Navigation("Contacts");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.PriceRange", b =>
                {
                    b.Navigation("LeadsPreferences");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.User", b =>
                {
                    b.Navigation("LeadsPreferences");
                });

            modelBuilder.Entity("TLA.Microservice.Domain.Entities.VehicleMaker", b =>
                {
                    b.Navigation("LeadsVehicleMakerChoices");
                });
#pragma warning restore 612, 618
        }
    }
}
